Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes

# PandaNode Class Reference

A basic node of the scene graph or data graph. More...

Inheritance diagram for PandaNode:

List of all members.

## Public Types
enum | FancyBits { FBTransform = 1, FBState = 2, FBEffects = 4, FBTag = 16, FBDrawMask = 32, FBCullCallback = 64 }
enum | UnexpectedChange { UCParents = 1, UCChildren = 2, UCTransform = 4, UCState = 8, UCDrawMask = 16 }
## Public Member Functions
| PandaNode (string name)
| addChild (PandaNode child_node, int sort, Thread current_thread)
| Adds a new child to the node.
| addChild (PandaNode child_node, int sort)
| Adds a new child to the node.
| addChild (PandaNode child_node)
| Adds a new child to the node.
| addStashed (PandaNode child_node, int sort, Thread current_thread)
| Adds a new child to the node, directly as a stashed child.
| addStashed (PandaNode child_node, int sort)
| Adds a new child to the node, directly as a stashed child.
| addStashed (PandaNode child_node)
| Adds a new child to the node, directly as a stashed child.
| adjustDrawMask (BitMaskunsigned int, 32 show_mask, BitMaskunsigned int, 32 hide_mask, BitMaskunsigned int, 32 clear_mask)
| Adjusts the hide/show bits of this particular node.
Light | asLight ()
| Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not.
| clearAttrib (TypeHandle type)
| Removes the render attribute of the given type from this node.
| clearAttrib (int slot)
| Removes the render attribute of the given type from this node.
| clearBounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node.
| clearEffect (TypeHandle type)
| Removes the render effect of the given type from this node.
| clearEffects (Thread current_thread)
| Resets this node to have no render effects.
| clearEffects ()
| Resets this node to have no render effects.
| clearPythonTag (string key)
| Removes the Python object defined for this key on this particular node.
| clearState (Thread current_thread)
| Resets this node to leave the render state alone.
| clearState ()
| Resets this node to leave the render state alone.
| clearTag (string key, Thread current_thread)
| Removes the value defined for this key on this particular node.
| clearTag (string key)
| Removes the value defined for this key on this particular node.
| clearTransform (Thread current_thread)
| Resets the transform on this node to the identity transform.
| clearTransform ()
| Resets the transform on this node to the identity transform.
| clearUnexpectedChange (unsigned int flags)
| Sets one or more of the PandaNode.UnexpectedChange bits off, indicating that the corresponding property may once again change on this node.
PandaNode | combineWith (PandaNode other)
| Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined.
int | compareTags (PandaNode const other)
| Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one.
PandaNode | copy ()
| A special Python method that is invoked by copy.copy(node).
| copyAllProperties (PandaNode other)
| Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one.
| copyChildren (PandaNode other, Thread current_thread)
| Makes another instance of all the children of the other node, copying them to this node.
| copyChildren (PandaNode other)
| Makes another instance of all the children of the other node, copying them to this node.
PandaNode | copySubgraph (Thread current_thread)
| Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.
PandaNode | copySubgraph ()
| Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.
| copyTags (PandaNode other)
| Copies all of the tags stored on the other node onto this node.
int | countNumDescendants ()
| Returns the number of nodes at and below this level.
PyObject | deepcopy (PyObject self, PyObject memo)
| A special Python method that is invoked by copy.deepcopy(node).
int | findChild (PandaNode node, Thread current_thread)
| Returns the index of the indicated child node, if it is a child, or -1 if it is not.
int | findChild (PandaNode node)
| Returns the index of the indicated child node, if it is a child, or -1 if it is not.
int | findParent (PandaNode node, Thread current_thread)
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.
int | findParent (PandaNode node)
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.
int | findStashed (PandaNode node, Thread current_thread)
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.
int | findStashed (PandaNode node)
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.
static BitMaskunsigned | getAllCameraMask ()
RenderAttrib const | getAttrib (TypeHandle type)
| Returns the render attribute of the indicated type, if it is defined on the node, or NULL if it is not.
RenderAttrib const | getAttrib (int slot)
| Returns the render attribute of the indicated type, if it is defined on the node, or NULL if it is not.
BoundingVolume const | getBounds (Thread current_thread)
| Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.
BoundingVolume const | getBounds ()
| Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.
BoundingVolume const | getBounds (UpdateSeq seq, Thread current_thread)
| This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.
BoundingVolume const | getBounds (UpdateSeq seq)
| This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.
BoundsType | getBoundsType ()
PandaNode | getChild (int n, Thread current_thread)
| Returns the nth child node of this node.
PandaNode | getChild (int n)
| Returns the nth child node of this node.
int | getChildSort (int n, Thread current_thread)
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).
int | getChildSort (int n)
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).
BitMaskunsigned | getDrawControlMask ()
BitMaskunsigned | getDrawShowMask ()
RenderEffect const | getEffect (TypeHandle type)
| Returns the render effect of the indicated type, if it is defined on the node, or NULL if it is not.
RenderEffects const | getEffects (Thread current_thread)
| Returns the complete RenderEffects that will be applied to this node.
RenderEffects const | getEffects ()
| Returns the complete RenderEffects that will be applied to this node.
int | getFancyBits (Thread current_thread)
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.
int | getFancyBits ()
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.
BoundingVolume const | getInternalBounds (Thread current_thread)
| Returns the node's internal bounding volume.
BoundingVolume const | getInternalBounds ()
| Returns the node's internal bounding volume.
int | getInternalVertices (Thread current_thread)
| Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.
int | getInternalVertices ()
| Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.
BitMaskunsigned | getIntoCollideMask ()
BitMaskunsigned | getLegalCollideMask ()
int | getNestedVertices (Thread current_thread)
| Returns the total number of vertices that will be rendered by this node and all of its descendents.
int | getNestedVertices ()
| Returns the total number of vertices that will be rendered by this node and all of its descendents.
BitMaskunsigned | getNetCollideMask (Thread current_thread)
BitMaskunsigned | getNetCollideMask ()
BitMaskunsigned | getNetDrawControlMask ()
BitMaskunsigned | getNetDrawShowMask ()
int | getNumChildren (Thread current_thread)
| Returns the number of child nodes this node has.
int | getNumChildren ()
| Returns the number of child nodes this node has.
int | getNumParents ()
| Returns the number of parent nodes this node has.
int | getNumParents (Thread current_thread)
| Returns the number of parent nodes this node has.
int | getNumStashed (Thread current_thread)
| Returns the number of stashed nodes this node has.
int | getNumStashed ()
| Returns the number of stashed nodes this node has.
RenderAttrib const | getOffClipPlanes (Thread current_thread)
| Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.
RenderAttrib const | getOffClipPlanes ()
| Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.
static BitMaskunsigned | getOverallBit ()
PandaNode | getParent (int n, Thread current_thread)
| Returns the nth parent node of this node.
PandaNode | getParent (int n)
| Returns the nth parent node of this node.
TransformState const | getPrevTransform (Thread current_thread)
| Returns the transform that has been set as this node's "previous" position.
TransformState const | getPrevTransform ()
| Returns the transform that has been set as this node's "previous" position.
PyObject | getPythonTag (string key)
| Retrieves the Python object that was previously set on this node for the particular key, if any.
PandaNode | getStashed (int n, Thread current_thread)
| Returns the nth stashed child of this node.
PandaNode | getStashed (int n)
| Returns the nth stashed child of this node.
int | getStashedSort (int n, Thread current_thread)
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).
int | getStashedSort (int n)
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).
RenderState const | getState (Thread current_thread)
| Returns the complete RenderState that will be applied to all nodes at this level and below, as set on this node.
RenderState const | getState ()
| Returns the complete RenderState that will be applied to all nodes at this level and below, as set on this node.
string | getTag (string key, Thread current_thread)
| Retrieves the user-defined value that was previously set on this node for the particular key, if any.
string | getTag (string key)
| Retrieves the user-defined value that was previously set on this node for the particular key, if any.
TransformState const | getTransform (Thread current_thread)
| Returns the transform that has been set on this particular node.
TransformState const | getTransform ()
| Returns the transform that has been set on this particular node.
unsigned int | getUnexpectedChange (unsigned int flags)
| Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set.
bool | hasAttrib (int slot)
| Returns true if there is a render attribute of the indicated type defined on this node, or false if there is not.
bool | hasAttrib (TypeHandle type)
| Returns true if there is a render attribute of the indicated type defined on this node, or false if there is not.
bool | hasDirtyPrevTransform ()
| Returns true if this node has the _dirty_prev_transform flag set, which indicates its _prev_transform is different from its _transform value (in pipeline stage 0).
bool | hasEffect (TypeHandle type)
| Returns true if there is a render effect of the indicated type defined on this node, or false if there is not.
bool | hasPythonTag (string key)
| Returns true if a Python object has been defined on this node for the particular key (even if that object is None), or false if no object has been set.
bool | hasTag (string key, Thread current_thread)
| Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.
bool | hasTag (string key)
| Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.
bool | hasTags ()
| Returns true if the node has any tags (or any Python tags) at all, false if it has none.
bool | isAmbientLight ()
| Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light.
bool | isBoundsStale ()
| Returns true if the bounding volume of this node is stale and will be implicitly recomputed at the next call to get_bounds(), or false if it is fresh and need not be recomputed.
bool | isCollisionNode ()
| A simple downcast check.
bool | isFinal ()
| Returns the current state of the "final" flag.
bool | isFinal (Thread current_thread)
| Returns the current state of the "final" flag.
bool | isGeomNode ()
| A simple downcast check.
bool | isLodNode ()
| A simple downcast check.
bool | isOverallHidden ()
| Returns true if the node has been hidden to all cameras by clearing its overall bit.
bool | isSceneRoot ()
| Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise.
bool | isUnderSceneRoot ()
| Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root.
| listTags (ostream out)
| Writes a list of all the tag keys assigned to the node to the indicated stream.
| listTags (ostream out, string separator)
| Writes a list of all the tag keys assigned to the node to the indicated stream.
| ls (ostream out, int indent_level)
| Lists all the nodes at and below the current path hierarchically.
PandaNode | makeCopy ()
| Returns a newly-allocated PandaNode that is a shallow copy of this one.
| markBoundsStale ()
| Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.
| markBoundsStale (Thread current_thread)
| Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.
| markInternalBoundsStale (Thread current_thread)
| Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.
| markInternalBoundsStale ()
| Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.
| output (ostream out)
| Outputs the Namable.
| prepareScene (GraphicsStateGuardianBase gsg, RenderState const node_state)
| Walks through the scene graph beginning at this node, and does whatever initialization is required to render the scene properly with the indicated GSG.
| removeAllChildren ()
| Removes all the children from the node at once, including stashed children.
| removeAllChildren (Thread current_thread)
| Removes all the children from the node at once, including stashed children.
bool | removeChild (PandaNode child_node)
| Removes the indicated child from the node.
| removeChild (int child_index)
| Removes the nth child from the node.
bool | removeChild (PandaNode child_node, Thread current_thread)
| Removes the indicated child from the node.
| removeChild (int child_index, Thread current_thread)
| Removes the nth child from the node.
| removeStashed (int child_index)
| Removes the nth stashed child from the node.
| removeStashed (int child_index, Thread current_thread)
| Removes the nth stashed child from the node.
bool | replaceChild (PandaNode orig_child, PandaNode new_child)
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.
bool | replaceChild (PandaNode orig_child, PandaNode new_child, Thread current_thread)
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.
| replaceNode (PandaNode other)
| Inserts this node into the scene graph in place of the other one, and removes the other node.
| resetPrevTransform ()
| Resets the transform that represents this node's "previous" position to the same as the current transform.
| resetPrevTransform (Thread current_thread)
| Resets the transform that represents this node's "previous" position to the same as the current transform.
| setAttrib (RenderAttrib const attrib)
| Adds the indicated render attribute to the scene graph on this node.
| setAttrib (RenderAttrib const attrib, int override)
| Adds the indicated render attribute to the scene graph on this node.
| setBound (BoundingVolume const volume)
| Deprecated.
| setBounds (BoundingVolume const volume)
| Resets the bounding volume so that it is the indicated volume.
| setBoundsType (BoundsType bounds_type)
| Specifies the desired type of bounding volume that will be created for this node.
| setEffect (RenderEffect const effect)
| Adds the indicated render effect to the scene graph on this node.
| setEffects (RenderEffects const effects)
| Sets the complete RenderEffects that will be applied this node.
| setEffects (RenderEffects const effects, Thread current_thread)
| Sets the complete RenderEffects that will be applied this node.
| setFinal (bool flag)
| Sets the "final" flag on this PandaNode.
| setIntoCollideMask (BitMaskunsigned int, 32 mask)
| Sets the "into" CollideMask.
| setOverallHidden (bool overall_hidden)
| Sets or clears the hidden flag.
| setPrevTransform (TransformState const transform, Thread current_thread)
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
| setPrevTransform (TransformState const transform)
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
| setPythonTag (string key, PyObject value)
| Associates an arbitrary Python object with a user-defined key which is stored on the node.
| setState (RenderState const state, Thread current_thread)
| Sets the complete RenderState that will be applied to all nodes at this level and below.
| setState (RenderState const state)
| Sets the complete RenderState that will be applied to all nodes at this level and below.
| setTag (string key, string value)
| Associates a user-defined value with a user-defined key which is stored on the node.
| setTag (string key, string value, Thread current_thread)
| Associates a user-defined value with a user-defined key which is stored on the node.
| setTransform (TransformState const transform)
| Sets the transform that will be applied to this node and below.
| setTransform (TransformState const transform, Thread current_thread)
| Sets the transform that will be applied to this node and below.
| setUnexpectedChange (unsigned int flags)
| Sets one or more of the PandaNode.UnexpectedChange bits on, indicating that the corresponding property should not change again on this node.
bool | stashChild (PandaNode child_node)
| Stashes the indicated child node.
| stashChild (int child_index)
| Stashes the indicated child node.
| stashChild (int child_index, Thread current_thread)
| Stashes the indicated child node.
bool | stashChild (PandaNode child_node, Thread current_thread)
| Stashes the indicated child node.
| stealChildren (PandaNode other, Thread current_thread)
| Moves all the children from the other node onto this node.
| stealChildren (PandaNode other)
| Moves all the children from the other node onto this node.
| unstashChild (int stashed_index)
| Returns the indicated stashed node to normal child status.
bool | unstashChild (PandaNode child_node, Thread current_thread)
| Returns the indicated stashed node to normal child status.
bool | unstashChild (PandaNode child_node)
| Returns the indicated stashed node to normal child status.
| unstashChild (int stashed_index, Thread current_thread)
| Returns the indicated stashed node to normal child status.
| write (ostream out, int indent_level)
## Static Public Member Functions
static PandaNode | decodeFromBamStream (string data, BamReader reader)
| Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.
static PandaNode | decodeFromBamStream (string data)
| Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.
static TypeHandle | getClassType ()
static | resetAllPrevTransform (Thread current_thread)
| Visits all nodes in the world with the _dirty_prev_transform flag--that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0--and resets the _prev_transform to be the same as _transform.
static | resetAllPrevTransform ()
| Visits all nodes in the world with the _dirty_prev_transform flag--that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0--and resets the _prev_transform to be the same as _transform.
## Public Attributes
BitMaskunsigned | int
| Returns the set of bits in draw_show_mask that are considered meaningful.
## Static Public Attributes
static BitMaskunsigned | int
| Returns the special bit that, when specifically cleared in the node's DrawMask, indicates that the node is hidden to all cameras, regardless of the remaining DrawMask bits.

## Detailed Description

A basic node of the scene graph or data graph.

This is the base class of all specialized nodes, and also serves as a generic node with no special properties.

## Member Enumeration Documentation

enum FancyBits

Enumerator:

  FBTransform |
  FBState |
  FBEffects |
  FBTag |
  FBDrawMask |
  FBCullCallback |

enum UnexpectedChange

Enumerator:

  UCParents |
  UCChildren |
  UCTransform |
  UCState |
  UCDrawMask |

## Constructor & Destructor Documentation

PandaNode | ( | string | name | ) |

## Member Function Documentation

addChild | ( | PandaNode | child_node,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Adds a new child to the node.

The child is added in the relative position indicated by sort; if all children have the same sort index, the child is added at the end.

If the same child is added to a node more than once, the previous instance is first removed.

addChild | ( | PandaNode | child_node,
|  | int | sort
| ) |  |

Adds a new child to the node.

The child is added in the relative position indicated by sort; if all children have the same sort index, the child is added at the end.

If the same child is added to a node more than once, the previous instance is first removed.

addChild | ( | PandaNode | child_node | ) |

Adds a new child to the node.

The child is added in the relative position indicated by sort; if all children have the same sort index, the child is added at the end.

If the same child is added to a node more than once, the previous instance is first removed.

addStashed | ( | PandaNode | child_node,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Adds a new child to the node, directly as a stashed child.

The child is not added in the normal sense, but will be revealed if unstash_child() is called on it later.

If the same child is added to a node more than once, the previous instance is first removed.

This can only be called from the top pipeline stage (i.e. from App).

addStashed | ( | PandaNode | child_node,
|  | int | sort
| ) |  |

Adds a new child to the node, directly as a stashed child.

The child is not added in the normal sense, but will be revealed if unstash_child() is called on it later.

If the same child is added to a node more than once, the previous instance is first removed.

This can only be called from the top pipeline stage (i.e. from App).

addStashed | ( | PandaNode | child_node | ) |

Adds a new child to the node, directly as a stashed child.

The child is not added in the normal sense, but will be revealed if unstash_child() is called on it later.

If the same child is added to a node more than once, the previous instance is first removed.

This can only be called from the top pipeline stage (i.e. from App).

adjustDrawMask | ( | BitMaskunsigned | int,
|  | 32 | show_mask,
|  | BitMaskunsigned | int,
|  | 32 | hide_mask,
|  | BitMaskunsigned | int,
|  | 32 | clear_mask
| ) |  |

Adjusts the hide/show bits of this particular node.

These three parameters can be used to adjust the _draw_control_mask and _draw_show_mask independently, which work together to provide per-camera visibility for the node and its descendents.

_draw_control_mask indicates the bits in _draw_show_mask that are significant. Each different bit corresponds to a different camera (and these bits are assigned via Camera.set_camera_mask()).

Where _draw_control_mask has a 1 bit, a 1 bit in _draw_show_mask indicates the node is visible to that camera, and a 0 bit indicates the node is hidden to that camera. Where _draw_control_mask is 0, the node is hidden only if a parent node is hidden.

The meaning of the three parameters is as follows:

Wherever show_mask is 1, _draw_show_mask and _draw_control_mask will be set 1. Thus, show_mask indicates the set of cameras to which the node should be shown.

Wherever hide_mask is 1, _draw_show_mask will be set 0 and _draw_control_mask will be set 1. Thus, hide_mask indicates the set of cameras from which the node should be hidden.

Wherever clear_mask is 1, _draw_control_mask will be set 0. Thus, clear_mask indicates the set of cameras from which the hidden state should be inherited from a parent.

Light asLight | ( |  | ) |

Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not.

clearAttrib | ( | TypeHandle | type | ) |

Removes the render attribute of the given type from this node.

This node, and the subgraph below, will now inherit the indicated render attribute from the nodes above this one.

clearAttrib | ( | int | slot | ) |

Removes the render attribute of the given type from this node.

This node, and the subgraph below, will now inherit the indicated render attribute from the nodes above this one.

clearBounds | ( |  | ) |

Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node.

clearEffect | ( | TypeHandle | type | ) |

Removes the render effect of the given type from this node.

clearEffects | ( | Thread | current_thread | ) |

Resets this node to have no render effects.

clearEffects | ( |  | ) |

Resets this node to have no render effects.

clearPythonTag | ( | string | key | ) |

Removes the Python object defined for this key on this particular node.

After a call to clear_python_tag(), has_python_tag() will return false for the indicated key.

clearState | ( | Thread | current_thread | ) |

Resets this node to leave the render state alone.

Nodes at this level and below will once again inherit their render state unchanged from the nodes above this level.

clearState | ( |  | ) |

Resets this node to leave the render state alone.

Nodes at this level and below will once again inherit their render state unchanged from the nodes above this level.

clearTag | ( | string | key,
|  | Thread | current_thread
| ) |  |

Removes the value defined for this key on this particular node.

After a call to clear_tag(), has_tag() will return false for the indicated key.

clearTag | ( | string | key | ) |

Removes the value defined for this key on this particular node.

After a call to clear_tag(), has_tag() will return false for the indicated key.

clearTransform | ( | Thread | current_thread | ) |

Resets the transform on this node to the identity transform.

clearTransform | ( |  | ) |

Resets the transform on this node to the identity transform.

clearUnexpectedChange | ( | unsigned int | flags | ) |

Sets one or more of the PandaNode.UnexpectedChange bits off, indicating that the corresponding property may once again change on this node.

See set_unexpected_change().

The input parameter is the union of bits that are to be cleared.

Since this is a developer debugging tool only, this function does nothing in a production (NDEBUG) build.

PandaNode combineWith | ( | PandaNode | other | ) |

Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined.

The return value may be this, other, or a new PandaNode altogether.

This function is called from GraphReducer.flatten(), and need not deal with children; its job is just to decide whether to collapse the two PandaNodes and what the collapsed PandaNode should look like.

int compareTags | ( | PandaNode const | other | ) |

Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one.

If this returns 0, the tags are identical. If it returns other than 0, then the tags are different; and the nodes may be sorted into a consistent (but arbitrary) ordering based on this number.

PandaNode copy | ( |  | ) |

A special Python method that is invoked by copy.copy(node).

Unlike the PandaNode copy constructor, which creates a new node without children, this shares child pointers (essentially making every child an instance). This is intended to simulate the behavior of copy.copy() for other objects.

copyAllProperties | ( | PandaNode | other | ) |

Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one.

Typically this is used to prepare a node to replace another node in the scene graph (also see replace_node()).

copyChildren | ( | PandaNode | other,
|  | Thread | current_thread
| ) |  |

Makes another instance of all the children of the other node, copying them to this node.

copyChildren | ( | PandaNode | other | ) |

Makes another instance of all the children of the other node, copying them to this node.

PandaNode copySubgraph | ( |  | ) |

Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.

Some data may still be shared from the original (e.g. vertex index tables), but nothing that will impede normal use of the PandaNode.

PandaNode copySubgraph | ( | Thread | current_thread | ) |

Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.

Some data may still be shared from the original (e.g. vertex index tables), but nothing that will impede normal use of the PandaNode.

copyTags | ( | PandaNode | other | ) |

Copies all of the tags stored on the other node onto this node.

If a particular tag exists on both nodes, the contents of this node's value is replaced by that of the other.

int countNumDescendants | ( |  | ) |

Returns the number of nodes at and below this level.

static PandaNode decodeFromBamStream | ( | string | data,
|  | BamReader | reader
| ) |  | `[static]`

Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.

Returns NULL on error.

This method is intended to replace decode_raw_from_bam_stream() when you know the stream in question returns an object of type PandaNode, allowing for easier reference count management. Note that the caller is still responsible for maintaining the reference count on the return value.

static PandaNode decodeFromBamStream | ( | string | data | ) | `[static]`

Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.

Returns NULL on error.

This method is intended to replace decode_raw_from_bam_stream() when you know the stream in question returns an object of type PandaNode, allowing for easier reference count management. Note that the caller is still responsible for maintaining the reference count on the return value.

PyObject deepcopy | ( | PyObject | self,
|  | PyObject | memo
| ) |  |

A special Python method that is invoked by copy.deepcopy(node).

This calls copy_subgraph() unless the node is already present in the provided dictionary.

int findChild | ( | PandaNode | node,
|  | Thread | current_thread
| ) |  |

Returns the index of the indicated child node, if it is a child, or -1 if it is not.

int findChild | ( | PandaNode | node | ) |

Returns the index of the indicated child node, if it is a child, or -1 if it is not.

int findParent | ( | PandaNode | node,
|  | Thread | current_thread
| ) |  |

Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.

int findParent | ( | PandaNode | node | ) |

Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.

int findStashed | ( | PandaNode | node,
|  | Thread | current_thread
| ) |  |

Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.

int findStashed | ( | PandaNode | node | ) |

Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.

static BitMaskunsigned getAllCameraMask | ( |  | ) |

RenderAttrib const getAttrib | ( | int | slot | ) |

Returns the render attribute of the indicated type, if it is defined on the node, or NULL if it is not.

This checks only what is set on this particular node level, and has nothing to do with what render attributes may be inherited from parent nodes.

RenderAttrib const getAttrib | ( | TypeHandle | type | ) |

Returns the render attribute of the indicated type, if it is defined on the node, or NULL if it is not.

This checks only what is set on this particular node level, and has nothing to do with what render attributes may be inherited from parent nodes.

BoundingVolume const getBounds | ( | Thread | current_thread | ) |

Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.

BoundingVolume const getBounds | ( |  | ) |

Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.

BoundingVolume const getBounds | ( | UpdateSeq | seq,
|  | Thread | current_thread
| ) |  |

This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.

When this sequence number changes, it indicates that the bounding volume might have changed, e.g. because some nested child's bounding volume has changed.

Although this might occasionally increment without changing the bounding volume, the bounding volume will never change without incrementing this counter, so as long as this counter remains unchanged you can be confident the bounding volume is also unchanged.

BoundingVolume const getBounds | ( | UpdateSeq | seq | ) |

This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.

When this sequence number changes, it indicates that the bounding volume might have changed, e.g. because some nested child's bounding volume has changed.

Although this might occasionally increment without changing the bounding volume, the bounding volume will never change without incrementing this counter, so as long as this counter remains unchanged you can be confident the bounding volume is also unchanged.

BoundsType getBoundsType | ( |  | ) |

PandaNode getChild | ( | int | n | ) |

Returns the nth child node of this node.

See get_num_children(). Also see get_children(), if your intention is to iterate through the complete list of children; get_children() is preferable in this case.

PandaNode getChild | ( | int | n,
|  | Thread | current_thread
| ) |  |

Returns the nth child node of this node.

See get_num_children(). Also see get_children(), if your intention is to iterate through the complete list of children; get_children() is preferable in this case.

int getChildSort | ( | int | n,
|  | Thread | current_thread
| ) |  |

Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).

See get_num_children().

int getChildSort | ( | int | n | ) |

Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).

See get_num_children().

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from ReferenceCount.

Reimplemented in PGItem, PGButton, PGTop, PGEntry, PGVirtualFrame, PGSliderBar, PGScrollFrame, PGWaitBar, ButtonThrower, DataNode, MouseInterfaceNode, DriveInterface, MouseSubregion, MouseWatcher, Trackball, Transform2SG, TextNode, ParametricCurve, CubicCurveseg, PiecewiseCurve, HermiteCurve, NurbsCurve, RopeNode, SheetNode, AnalogNode, ButtonNode, DialNode, MouseAndKeyboard, TrackerNode, VirtualMouse, CollisionNode, CollisionVisualizer, Character, PartBundleNode, AnimBundleNode, FrameRateMeter, SceneGraphAnalyzerMeter, RigidBodyCombiner, LensNode, Camera, PlaneNode, GeomNode, Fog, ModelNode, ModelRoot, OccluderNode, PolylightNode, PortalNode, LightNode, AmbientLight, CallbackNode, LightLensNode, DirectionalLight, LODNode, FadeLODNode, PointLight, SelectiveChildNode, SequenceNode, Spotlight, SwitchNode, UvScrollNode, and MouseRecorder.

BitMaskunsigned getDrawControlMask | ( |  | ) |

BitMaskunsigned getDrawShowMask | ( |  | ) |

RenderEffect const getEffect | ( | TypeHandle | type | ) |

Returns the render effect of the indicated type, if it is defined on the node, or NULL if it is not.

RenderEffects const getEffects | ( | Thread | current_thread | ) |

Returns the complete RenderEffects that will be applied to this node.

RenderEffects const getEffects | ( |  | ) |

Returns the complete RenderEffects that will be applied to this node.

int getFancyBits | ( |  | ) |

Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.

If this returns 0, the node has nothing interesting about it. This is intended to speed traversal by quickly skipping past nodes that don't particularly affect the render state.

int getFancyBits | ( | Thread | current_thread | ) |

Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.

If this returns 0, the node has nothing interesting about it. This is intended to speed traversal by quickly skipping past nodes that don't particularly affect the render state.

BoundingVolume const getInternalBounds | ( | Thread | current_thread | ) |

Returns the node's internal bounding volume.

This is the bounding volume around the node alone, without including children. If the user has called set_bounds(), it will be the specified bounding volume.

BoundingVolume const getInternalBounds | ( |  | ) |

Returns the node's internal bounding volume.

This is the bounding volume around the node alone, without including children. If the user has called set_bounds(), it will be the specified bounding volume.

int getInternalVertices | ( | Thread | current_thread | ) |

Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.

This may not include all vertices for certain dynamic effects.

int getInternalVertices | ( |  | ) |

Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.

This may not include all vertices for certain dynamic effects.

BitMaskunsigned getIntoCollideMask | ( |  | ) |

Reimplemented in CollisionNode.

BitMaskunsigned getLegalCollideMask | ( |  | ) |

int getNestedVertices | ( | Thread | current_thread | ) |

Returns the total number of vertices that will be rendered by this node and all of its descendents.

This is not necessarily an accurate count of vertices that will actually be rendered, since this will include all vertices of all LOD's, and it will also include hidden nodes. It may also omit or only approximate certain kinds of dynamic geometry. However, it will not include stashed nodes.

int getNestedVertices | ( |  | ) |

Returns the total number of vertices that will be rendered by this node and all of its descendents.

This is not necessarily an accurate count of vertices that will actually be rendered, since this will include all vertices of all LOD's, and it will also include hidden nodes. It may also omit or only approximate certain kinds of dynamic geometry. However, it will not include stashed nodes.

BitMaskunsigned getNetCollideMask | ( |  | ) |

BitMaskunsigned getNetCollideMask | ( | Thread | current_thread | ) |

BitMaskunsigned getNetDrawControlMask | ( |  | ) |

BitMaskunsigned getNetDrawShowMask | ( |  | ) |

int getNumChildren | ( | Thread | current_thread | ) |

Returns the number of child nodes this node has.

The order of the child nodes *is* meaningful and is based on the sort number that was passed to add_child(), and also on the order in which the nodes were added.

int getNumChildren | ( |  | ) |

Returns the number of child nodes this node has.

The order of the child nodes *is* meaningful and is based on the sort number that was passed to add_child(), and also on the order in which the nodes were added.

int getNumParents | ( |  | ) |

Returns the number of parent nodes this node has.

If this number is greater than 1, the node has been multiply instanced. The order of the parent nodes is not meaningful and is not related to the order in which the node was instanced to them.

int getNumParents | ( | Thread | current_thread | ) |

Returns the number of parent nodes this node has.

If this number is greater than 1, the node has been multiply instanced. The order of the parent nodes is not meaningful and is not related to the order in which the node was instanced to them.

int getNumStashed | ( | Thread | current_thread | ) |

Returns the number of stashed nodes this node has.

These are former children of the node that have been moved to the special stashed list via stash_child().

int getNumStashed | ( |  | ) |

Returns the number of stashed nodes this node has.

These are former children of the node that have been moved to the special stashed list via stash_child().

RenderAttrib const getOffClipPlanes | ( |  | ) |

Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.

RenderAttrib const getOffClipPlanes | ( | Thread | current_thread | ) |

Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.

static BitMaskunsigned getOverallBit | ( |  | ) |

PandaNode getParent | ( | int | n | ) |

Returns the nth parent node of this node.

See get_num_parents(). Also see get_parents(), if your intention is to iterate through the complete list of parents; get_parents() is preferable in this case.

PandaNode getParent | ( | int | n,
|  | Thread | current_thread
| ) |  |

Returns the nth parent node of this node.

See get_num_parents(). Also see get_parents(), if your intention is to iterate through the complete list of parents; get_parents() is preferable in this case.

TransformState const getPrevTransform | ( | Thread | current_thread | ) |

Returns the transform that has been set as this node's "previous" position.

See set_prev_transform().

TransformState const getPrevTransform | ( |  | ) |

Returns the transform that has been set as this node's "previous" position.

See set_prev_transform().

PyObject getPythonTag | ( | string | key | ) |

Retrieves the Python object that was previously set on this node for the particular key, if any.

If no value has been previously set, returns None.

PandaNode getStashed | ( | int | n,
|  | Thread | current_thread
| ) |  |

Returns the nth stashed child of this node.

See get_num_stashed(). Also see get_stashed(), if your intention is to iterate through the complete list of stashed children; get_stashed() is preferable in this case.

PandaNode getStashed | ( | int | n | ) |

Returns the nth stashed child of this node.

See get_num_stashed(). Also see get_stashed(), if your intention is to iterate through the complete list of stashed children; get_stashed() is preferable in this case.

int getStashedSort | ( | int | n | ) |

Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).

See get_num_stashed().

int getStashedSort | ( | int | n,
|  | Thread | current_thread
| ) |  |

Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).

See get_num_stashed().

RenderState const getState | ( | Thread | current_thread | ) |

Returns the complete RenderState that will be applied to all nodes at this level and below, as set on this node.

This returns only the RenderState set on this particular node, and has nothing to do with state that might be inherited from above.

RenderState const getState | ( |  | ) |

Returns the complete RenderState that will be applied to all nodes at this level and below, as set on this node.

This returns only the RenderState set on this particular node, and has nothing to do with state that might be inherited from above.

Reimplemented in PGItem.

string getTag | ( | string | key,
|  | Thread | current_thread
| ) |  |

Retrieves the user-defined value that was previously set on this node for the particular key, if any.

If no value has been previously set, returns the empty string.

string getTag | ( | string | key | ) |

Retrieves the user-defined value that was previously set on this node for the particular key, if any.

If no value has been previously set, returns the empty string.

TransformState const getTransform | ( |  | ) |

Returns the transform that has been set on this particular node.

This is not the net transform from the root, but simply the transform on this particular node.

Reimplemented in TextNode, and TrackerNode.

TransformState const getTransform | ( | Thread | current_thread | ) |

Returns the transform that has been set on this particular node.

This is not the net transform from the root, but simply the transform on this particular node.

unsigned int getUnexpectedChange | ( | unsigned int | flags | ) |

Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set.

More specifically, this returns the particular set of bits (masked by the input parameter) that have been set on this node. See set_unexpected_change().

Since this is a developer debugging tool only, this function always returns zero in a production (NDEBUG) build.

bool hasAttrib | ( | int | slot | ) |

Returns true if there is a render attribute of the indicated type defined on this node, or false if there is not.

bool hasAttrib | ( | TypeHandle | type | ) |

Returns true if there is a render attribute of the indicated type defined on this node, or false if there is not.

bool hasDirtyPrevTransform | ( |  | ) |

Returns true if this node has the _dirty_prev_transform flag set, which indicates its _prev_transform is different from its _transform value (in pipeline stage 0).

In this case, the node will be visited by reset_prev_transform().

bool hasEffect | ( | TypeHandle | type | ) |

Returns true if there is a render effect of the indicated type defined on this node, or false if there is not.

bool hasPythonTag | ( | string | key | ) |

Returns true if a Python object has been defined on this node for the particular key (even if that object is None), or false if no object has been set.

bool hasTag | ( | string | key,
|  | Thread | current_thread
| ) |  |

Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.

bool hasTag | ( | string | key | ) |

Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.

bool hasTags | ( |  | ) |

Returns true if the node has any tags (or any Python tags) at all, false if it has none.

bool isAmbientLight | ( |  | ) |

Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light.

bool isBoundsStale | ( |  | ) |

Returns true if the bounding volume of this node is stale and will be implicitly recomputed at the next call to get_bounds(), or false if it is fresh and need not be recomputed.

bool isCollisionNode | ( |  | ) |

A simple downcast check.

Returns true if this kind of node happens to inherit from CollisionNode, false otherwise.

This is provided as a a faster alternative to calling is_of_type(CollisionNode.get_class_type()).

bool isFinal | ( | Thread | current_thread | ) |

Returns the current state of the "final" flag.

Initially, this flag is off (false), but it may be changed by an explicit call to set_final(). See set_final().

bool isFinal | ( |  | ) |

Returns the current state of the "final" flag.

Initially, this flag is off (false), but it may be changed by an explicit call to set_final(). See set_final().

bool isGeomNode | ( |  | ) |

A simple downcast check.

Returns true if this kind of node happens to inherit from GeomNode, false otherwise.

This is provided as a a faster alternative to calling is_of_type(GeomNode.get_class_type()), since this test is so important to rendering.

bool isLodNode | ( |  | ) |

A simple downcast check.

Returns true if this kind of node happens to inherit from LODNode, false otherwise.

This is provided as a a faster alternative to calling is_of_type(LODNode.get_class_type()).

bool isOverallHidden | ( |  | ) |

Returns true if the node has been hidden to all cameras by clearing its overall bit.

bool isSceneRoot | ( |  | ) |

Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise.

bool isUnderSceneRoot | ( |  | ) |

Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root.

If this is true, this node may potentially be traversed by the render traverser. Stashed nodes don't count for this purpose, but hidden nodes do.

listTags | ( | ostream | out,
|  | string | separator
| ) |  |

Writes a list of all the tag keys assigned to the node to the indicated stream.

Writes one instance of the separator following each key (but does not write a terminal separator). The value associated with each key is not written.

This is mainly for the benefit of the realtime user, to see the list of all of the associated tag keys.

listTags | ( | ostream | out | ) |

Writes a list of all the tag keys assigned to the node to the indicated stream.

Writes one instance of the separator following each key (but does not write a terminal separator). The value associated with each key is not written.

This is mainly for the benefit of the realtime user, to see the list of all of the associated tag keys.

ls | ( | ostream | out,
|  | int | indent_level
| ) |  |

Lists all the nodes at and below the current path hierarchically.

PandaNode makeCopy | ( |  | ) |

Returns a newly-allocated PandaNode that is a shallow copy of this one.

It will be a different pointer, but its internal data may or may not be shared with that of the original PandaNode. No children will be copied.

markBoundsStale | ( |  | ) |

Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.

With no parameters, this means to iterate through all stages including and upstream of the current pipeline stage.

This method is intended for internal use; usually it is not necessary for a user to call this directly. It will be called automatically by derived classes when appropriate.

markBoundsStale | ( | Thread | current_thread | ) |

Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.

With no parameters, this means to iterate through all stages including and upstream of the current pipeline stage.

This method is intended for internal use; usually it is not necessary for a user to call this directly. It will be called automatically by derived classes when appropriate.

markInternalBoundsStale | ( |  | ) |

Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.

With no parameters, this means to iterate through all stages including and upstream of the current pipeline stage.

It is normally not necessary to call this method directly; each node should be responsible for calling it when its internals have changed.

markInternalBoundsStale | ( | Thread | current_thread | ) |

Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.

With no parameters, this means to iterate through all stages including and upstream of the current pipeline stage.

It is normally not necessary to call this method directly; each node should be responsible for calling it when its internals have changed.

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

Reimplemented in TextNode, LightNode, and LightLensNode.

prepareScene | ( | GraphicsStateGuardianBase | gsg,
|  | RenderState const | node_state
| ) |  |

Walks through the scene graph beginning at this node, and does whatever initialization is required to render the scene properly with the indicated GSG.

It is not strictly necessary to call this, since the GSG will initialize itself when the scene is rendered, but this may take some of the overhead away from that process.

In particular, this will ensure that textures and vertex buffers within the scene are loaded into graphics memory.

removeAllChildren | ( | Thread | current_thread | ) |

Removes all the children from the node at once, including stashed children.

This can only be called from the top pipeline stage (i.e. from App).

removeAllChildren | ( |  | ) |

Removes all the children from the node at once, including stashed children.

This can only be called from the top pipeline stage (i.e. from App).

removeChild | ( | int | child_index | ) |

Removes the nth child from the node.

removeChild | ( | int | child_index,
|  | Thread | current_thread
| ) |  |

Removes the nth child from the node.

bool removeChild | ( | PandaNode | child_node,
|  | Thread | current_thread
| ) |  |

Removes the indicated child from the node.

Returns true if the child was removed, false if it was not already a child of the node. This will also successfully remove the child if it had been stashed.

bool removeChild | ( | PandaNode | child_node | ) |

Removes the indicated child from the node.

Returns true if the child was removed, false if it was not already a child of the node. This will also successfully remove the child if it had been stashed.

removeStashed | ( | int | child_index | ) |

Removes the nth stashed child from the node.

removeStashed | ( | int | child_index,
|  | Thread | current_thread
| ) |  |

Removes the nth stashed child from the node.

bool replaceChild | ( | PandaNode | orig_child,
|  | PandaNode | new_child
| ) |  |

Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.

Returns true if the replacement is made, or false if the node is not a child or if there is some other problem.

bool replaceChild | ( | PandaNode | orig_child,
|  | PandaNode | new_child,
|  | Thread | current_thread
| ) |  |

Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.

Returns true if the replacement is made, or false if the node is not a child or if there is some other problem.

replaceNode | ( | PandaNode | other | ) |

Inserts this node into the scene graph in place of the other one, and removes the other node.

All scene graph attributes (TransformState, RenderState, etc.) are copied to this node.

All children are moved to this node, and removed from the old node. The new node is left in the same place in the old node's parent's list of children.

Even NodePaths that reference the old node are updated in-place to reference the new node instead.

This method is intended to be used to replace a node of a given type in the scene graph with a node of a different type.

static resetAllPrevTransform | ( |  | ) | `[static]`

Visits all nodes in the world with the _dirty_prev_transform flag--that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0--and resets the _prev_transform to be the same as _transform.

static resetAllPrevTransform | ( | Thread | current_thread | ) | `[static]`

Visits all nodes in the world with the _dirty_prev_transform flag--that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0--and resets the _prev_transform to be the same as _transform.

resetPrevTransform | ( | Thread | current_thread | ) |

Resets the transform that represents this node's "previous" position to the same as the current transform.

This is not the same thing as clearing it to identity.

resetPrevTransform | ( |  | ) |

Resets the transform that represents this node's "previous" position to the same as the current transform.

This is not the same thing as clearing it to identity.

setAttrib | ( | RenderAttrib const | attrib,
|  | int | override
| ) |  |

Adds the indicated render attribute to the scene graph on this node.

This attribute will now apply to this node and everything below. If there was already an attribute of the same type, it is replaced.

setAttrib | ( | RenderAttrib const | attrib | ) |

Adds the indicated render attribute to the scene graph on this node.

This attribute will now apply to this node and everything below. If there was already an attribute of the same type, it is replaced.

setBound | ( | BoundingVolume const | volume | ) |

Deprecated.

Use set_bounds() instead.

setBounds | ( | BoundingVolume const | volume | ) |

Resets the bounding volume so that it is the indicated volume.

When it is explicitly set, the bounding volume will no longer be automatically computed according to the contents of the node itself, for nodes like GeomNodes and TextNodes that contain substance (but the bounding volume will still be automatically expanded to include its children).

Call clear_bounds() if you would like to return the bounding volume to its default behavior later.

setBoundsType | ( | BoundsType | bounds_type | ) |

Specifies the desired type of bounding volume that will be created for this node.

This is normally BoundingVolume.BT_default, which means to set the type according to the config variable "bounds-type".

If this is BT_sphere or BT_box, a BoundingSphere or BoundingBox is explicitly created. If it is BT_best, the appropriate type to best enclose the node's children is created.

This affects the bounding volume returned by get_bounds(), which is not exactly the same bounding volume modified by set_bounds(), because a new bounding volume has to be created that includes this node and all of its children.

setEffect | ( | RenderEffect const | effect | ) |

Adds the indicated render effect to the scene graph on this node.

If there was already an effect of the same type, it is replaced.

setEffects | ( | RenderEffects const | effects,
|  | Thread | current_thread
| ) |  |

Sets the complete RenderEffects that will be applied this node.

This completely replaces whatever has been set on this node via repeated calls to set_attrib().

setEffects | ( | RenderEffects const | effects | ) |

Sets the complete RenderEffects that will be applied this node.

This completely replaces whatever has been set on this node via repeated calls to set_attrib().

setFinal | ( | bool | flag | ) |

Sets the "final" flag on this PandaNode.

If this is true, than no bounding volume need be tested below it; a positive intersection with this node's bounding volume is deemed to be a positive intersection with all geometry inside.

This is useful to quickly force a larger bounding volume around a node when the GeomNodes themselves are inaccurate for some reason, without forcing a recompute of every nested bounding volume. It's also helpful when the bounding volume is tricked by some special properties, like billboards, that may move geometry out of its bounding volume otherwise.

setIntoCollideMask | ( | BitMaskunsigned | int,
|  | 32 | mask
| ) |  |

Sets the "into" CollideMask.

This specifies the set of bits that must be shared with a CollisionNode's "from" CollideMask in order for the CollisionNode to detect a collision with this particular node.

The actual CollideMask that will be set is masked by the return value from get_legal_collide_mask(). Thus, the into_collide_mask cannot be set to anything other than nonzero except for those types of nodes that can be collided into, such as CollisionNodes and GeomNodes.

Reimplemented in CollisionNode.

setOverallHidden | ( | bool | overall_hidden | ) |

Sets or clears the hidden flag.

When the hidden flag is true, the node and all of its children are invisible to all cameras, regardless of the setting of any draw masks. Setting the hidden flag to false restores the previous visibility as established by the draw masks.

This actually works by twiddling the reserved _overall_bit in the node's draw mask, which has special meaning.

setPrevTransform | ( | TransformState const | transform | ) |

Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.

setPrevTransform | ( | TransformState const | transform,
|  | Thread | current_thread
| ) |  |

Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.

setPythonTag | ( | string | key,
|  | PyObject | value
| ) |  |

Associates an arbitrary Python object with a user-defined key which is stored on the node.

This is similar to set_tag(), except it can store any Python object instead of just a string. However, the Python object is not recorded to a bam file.

Each unique key stores a different string value. There is no effective limit on the number of different keys that may be stored or on the length of any one key's value.

setState | ( | RenderState const | state,
|  | Thread | current_thread
| ) |  |

Sets the complete RenderState that will be applied to all nodes at this level and below.

(The actual state that will be applied to lower nodes is based on the composition of RenderStates from above this node as well). This completely replaces whatever has been set on this node via repeated calls to set_attrib().

setState | ( | RenderState const | state | ) |

Sets the complete RenderState that will be applied to all nodes at this level and below.

(The actual state that will be applied to lower nodes is based on the composition of RenderStates from above this node as well). This completely replaces whatever has been set on this node via repeated calls to set_attrib().

setTag | ( | string | key,
|  | string | value,
|  | Thread | current_thread
| ) |  |

Associates a user-defined value with a user-defined key which is stored on the node.

This value has no meaning to Panda; but it is stored indefinitely on the node until it is requested again.

Each unique key stores a different string value. There is no effective limit on the number of different keys that may be stored or on the length of any one key's value.

setTag | ( | string | key,
|  | string | value
| ) |  |

Associates a user-defined value with a user-defined key which is stored on the node.

This value has no meaning to Panda; but it is stored indefinitely on the node until it is requested again.

Each unique key stores a different string value. There is no effective limit on the number of different keys that may be stored or on the length of any one key's value.

setTransform | ( | TransformState const | transform,
|  | Thread | current_thread
| ) |  |

Sets the transform that will be applied to this node and below.

This defines a new coordinate space at this point in the scene graph and below.

setTransform | ( | TransformState const | transform | ) |

Sets the transform that will be applied to this node and below.

This defines a new coordinate space at this point in the scene graph and below.

setUnexpectedChange | ( | unsigned int | flags | ) |

Sets one or more of the PandaNode.UnexpectedChange bits on, indicating that the corresponding property should not change again on this node.

Once one of these bits has been set, if the property changes, an assertion failure will be raised, which is designed to assist the developer in identifying the troublesome code that modified the property unexpectedly.

The input parameter is the union of bits that are to be set. To clear these bits later, use clear_unexpected_change().

Since this is a developer debugging tool only, this function does nothing in a production (NDEBUG) build.

bool stashChild | ( | PandaNode | child_node | ) |

Stashes the indicated child node.

This removes the child from the list of active children and puts it on a special list of stashed children. This child node no longer contributes to the bounding volume of the PandaNode, and is not visited in normal traversals. It is invisible and uncollidable. The child may later be restored by calling unstash_child().

This function returns true if the child node was successfully stashed, or false if it was not a child of the node in the first place (e.g. it was previously stashed).

bool stashChild | ( | PandaNode | child_node,
|  | Thread | current_thread
| ) |  |

Stashes the indicated child node.

This removes the child from the list of active children and puts it on a special list of stashed children. This child node no longer contributes to the bounding volume of the PandaNode, and is not visited in normal traversals. It is invisible and uncollidable. The child may later be restored by calling unstash_child().

This function returns true if the child node was successfully stashed, or false if it was not a child of the node in the first place (e.g. it was previously stashed).

stashChild | ( | int | child_index,
|  | Thread | current_thread
| ) |  |

Stashes the indicated child node.

This removes the child from the list of active children and puts it on a special list of stashed children. This child node no longer contributes to the bounding volume of the PandaNode, and is not visited in normal traversals. It is invisible and uncollidable. The child may later be restored by calling unstash_child().

This can only be called from the top pipeline stage (i.e. from App).

stashChild | ( | int | child_index | ) |

Stashes the indicated child node.

This removes the child from the list of active children and puts it on a special list of stashed children. This child node no longer contributes to the bounding volume of the PandaNode, and is not visited in normal traversals. It is invisible and uncollidable. The child may later be restored by calling unstash_child().

This can only be called from the top pipeline stage (i.e. from App).

stealChildren | ( | PandaNode | other,
|  | Thread | current_thread
| ) |  |

Moves all the children from the other node onto this node.

Any NodePaths to child nodes of the other node are truncated, rather than moved to the new parent.

stealChildren | ( | PandaNode | other | ) |

Moves all the children from the other node onto this node.

Any NodePaths to child nodes of the other node are truncated, rather than moved to the new parent.

bool unstashChild | ( | PandaNode | child_node,
|  | Thread | current_thread
| ) |  |

Returns the indicated stashed node to normal child status.

This removes the child from the list of stashed children and puts it on the normal list of active children. This child node once again contributes to the bounding volume of the PandaNode, and will be visited in normal traversals. It is visible and collidable.

This function returns true if the child node was successfully stashed, or false if it was not a child of the node in the first place (e.g. it was previously stashed).

bool unstashChild | ( | PandaNode | child_node | ) |

Returns the indicated stashed node to normal child status.

This removes the child from the list of stashed children and puts it on the normal list of active children. This child node once again contributes to the bounding volume of the PandaNode, and will be visited in normal traversals. It is visible and collidable.

This function returns true if the child node was successfully stashed, or false if it was not a child of the node in the first place (e.g. it was previously stashed).

unstashChild | ( | int | stashed_index | ) |

Returns the indicated stashed node to normal child status.

This removes the child from the list of stashed children and puts it on the normal list of active children. This child node once again contributes to the bounding volume of the PandaNode, and will be visited in normal traversals. It is visible and collidable.

This can only be called from the top pipeline stage (i.e. from App).

unstashChild | ( | int | stashed_index,
|  | Thread | current_thread
| ) |  |

Returns the indicated stashed node to normal child status.

This removes the child from the list of stashed children and puts it on the normal list of active children. This child node once again contributes to the bounding volume of the PandaNode, and will be visited in normal traversals. It is visible and collidable.

This can only be called from the top pipeline stage (i.e. from App).

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

Reimplemented in TextNode, LightNode, and LightLensNode.

## Member Data Documentation

BitMaskunsigned int`[static]`

Returns the special bit that, when specifically cleared in the node's DrawMask, indicates that the node is hidden to all cameras, regardless of the remaining DrawMask bits.

Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below.

Returns the subset of CollideMask bits that may be set for this particular type of PandaNode.

Returns the "into" collide mask for this node.

Returns the union of all draw_show_mask values--of renderable nodes only--at this level and below.

Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited.

Returns the hide/show bits of this particular node.

Returns a DrawMask that is appropriate for rendering to all cameras.

See adjust_draw_mask().

A 1 bit in any position of this mask indicates that (a) this node has renderable children, and (b) some child of this node has made an explicit hide() or show_through() call for the corresponding bit.

If any bit in this mask is 0, there is no reason to traverse below this node for a camera with the corresponding camera_mask.

The bits in this mask that do not correspond to a 1 bit in the net_draw_control_mask are meaningless (and will be set to 1). For bits that *do* correspond to a 1 bit in the net_draw_control_mask, a 1 bit indicates that at least one child should be visible, while a 0 bit indicates that all children are hidden.

For most nodes, this is 0; it doesn't make sense to set a CollideMask for most kinds of nodes.

For nodes that can be collided with, such as GeomNode and CollisionNode, this returns all bits on.

Reimplemented in CollisionNode, CollisionNode, Camera, GeomNode, and PortalNode.

BitMaskunsigned int

Returns the set of bits in draw_show_mask that are considered meaningful.

Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below.

Returns the subset of CollideMask bits that may be set for this particular type of PandaNode.

Returns the "into" collide mask for this node.

Returns the union of all draw_show_mask values--of renderable nodes only--at this level and below.

Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited.

Returns the hide/show bits of this particular node.

See adjust_draw_mask().

A 1 bit in any position of this mask indicates that (a) this node has renderable children, and (b) some child of this node has made an explicit hide() or show_through() call for the corresponding bit.

If any bit in this mask is 0, there is no reason to traverse below this node for a camera with the corresponding camera_mask.

The bits in this mask that do not correspond to a 1 bit in the net_draw_control_mask are meaningless (and will be set to 1). For bits that *do* correspond to a 1 bit in the net_draw_control_mask, a 1 bit indicates that at least one child should be visible, while a 0 bit indicates that all children are hidden.

For most nodes, this is 0; it doesn't make sense to set a CollideMask for most kinds of nodes.

For nodes that can be collided with, such as GeomNode and CollisionNode, this returns all bits on.

Reimplemented in CollisionNode, CollisionNode, Camera, GeomNode, and PortalNode.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties